function formatXml (xml, indentString) {
  var reg = /(>)\s*(<)([\/]*)/g;
  var wsexp = / *(.*) +\n/g;
  var contexp = /(<.+>)(.+\n)/g;
  xml = xml.replace(reg, '$1\n$2$3').replace(wsexp, '$1\n').replace(contexp, '$1\n$2');
  var pad = 0;
  var formatted = '';
  var lines = xml.split('\n');
  var indent = 0;
  var lastType = 'other';
  // 4 types of tags - single, closing, opening, other (text, doctype, comment) - 4*4 = 16 transitions 
  var transitions = {
    single: {
      single: 0,
      closing: -1,
      opening: 0,
      other: 0
    },
    closing: {
      single: 0,
      closing: -1,
      opening: 0,
      other: 0
    },
    opening: {
      single: 1,
      closing: 0,
      opening: 1,
      other: 1
    },
    other: {
      single: 0,
      closing: -1,
      opening: 0,
      other: 0
    }
  };

  var strrepeat = function(str, num) {
    return new Array(num + 1).join(str);
  }

  for (var i = 0; i < lines.length; i++) {
    var ln = lines[i];
    var single = Boolean(ln.match(/<.+\/>/)); // is this line a single tag? ex. <br />
    var closing = Boolean(ln.match(/<\/.+>/)); // is this a closing tag? ex. </a>
    var opening = Boolean(ln.match(/<[^\!\?].*>/)); // is this even a tag (that's not <!something>)
    var type = single ? 'single' : closing ? 'closing' : opening ? 'opening' : 'other';
    indent += transitions[lastType][type];
    if (indent < 0) {
        indent = 0;
    }
    if (lastType === 'opening' && type === 'closing') {
      formatted = formatted.substr(0, formatted.length - 1) + ln + '\n'; // substr removes line break (\n) from prev loop
    }
    else {
      formatted += strrepeat(indentString, indent) + ln + '\n';
    }
    lastType = type;
  }

  return formatted;
};
